﻿using Microsoft.Maui.Controls.PlatformConfiguration;
using MusiLib.Model;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace MusiLib.DataContractPersistance
{
    public class DataContractPers : IPersistanceManager
    {
        public string FilePath { get; set; } = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "/musilib";
        public string FileNameP { get; set; } = "UserFavoris.xml";
        public string FileNameU { get; set; } = "UserData.xml";

        public (List<Partition>, List<Utilisateur>) chargeDonnees()
        {
          
            var serializerU = new DataContractSerializer(typeof(Utilisateur));

            List<Utilisateur> util = new List<Utilisateur>();

            using (Stream stream = File.OpenRead(Path.Combine(FilePath, FileNameU)))
            {
                util = serializerU.ReadObject(stream) as List<Utilisateur>;
            }

            return (new List<Partition>(), util);
        }

        public void sauvegardeDonnees(List<Partition> p, List<Utilisateur> u)
        {

            var serializerU = new DataContractSerializer(typeof(Utilisateur));

            if (!Directory.Exists(FilePath))
            {
                System.Diagnostics.Debug.WriteLine("Directory créé à l'instant");
                System.Diagnostics.Debug.WriteLine(FilePath);
                Directory.CreateDirectory(FilePath);
            }
            else
            {
                using (Stream stream = File.Create(Path.Combine(FilePath, FileNameU)))
                {
                    serializerU.WriteObject(stream, u);
                }
            }
        }
    }
}
